using System.Web.Mvc;
using System.Web.Routing;
using System.Web;

[assembly: WebActivator.PreApplicationStartMethod(typeof($rootnamespace$.AppStart_Metaweblog), "Start")]

namespace $rootnamespace$ {
    public static class AppStart_Metaweblog {

        public static void Start() {
            RouteTable.Routes.MapHttpHandler<MetaWeblog.MetaWeblog>("metaweblogapi.ashx");
        }

    }

    public static class RouteExtensions
    {

        public static void MapHttpHandler<THandler>(this RouteCollection routes,
          string url) where THandler : IHttpHandler
        {
            routes.MapHttpHandler<THandler>(null, url, null, null);
        }

        public static void MapHttpHandler<THandler>(this RouteCollection routes,
                string name, string url, object defaults, object constraints)
                where THandler : IHttpHandler
        {
            var route = new HandlerRoute(url, new HttpHandlerRouteHandler<THandler>());
            route.Defaults = new RouteValueDictionary(defaults);
            route.Constraints = new RouteValueDictionary(constraints);
            routes.Add(name, route);
        }
    }

    public class HandlerRoute : Route {
        public HandlerRoute(string url, IRouteHandler handler) : base(url, handler) {
        }

        public override VirtualPathData GetVirtualPath(RequestContext requestContext, RouteValueDictionary values)
        {
            return null;
        }
    }



    public class HttpHandlerRouteHandler<THandler> : IRouteHandler where THandler : IHttpHandler
    {
        public IHttpHandler GetHttpHandler(RequestContext requestContext)
        {
            //nice, ask MVC3 for my type.
            return DependencyResolver.Current.GetService<THandler>();
        }
    }
}
